Daily bump.
[official-gcc.git] / configure.in
blob7265f49a87f7d4b267e9e06447b5e755a2e5ce67
1 #! /bin/bash
2 ##############################################################################
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
17 # Copyright (C) 1992, 93, 94, 95, 96, 97, 1998, 1999 Free Software Foundation, Inc.
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
33 ##############################################################################
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
42 # these libraries are used by various programs built for the host environment
44 host_libs="intl mmalloc libiberty opcodes bfd readline gash db tcl tk tclX itcl tix libgui"
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
50 # these tools are built for the host environment
51 # Note, the powerpc-eabi build depends on sim occurring before gdb in order to
52 # know that we are building the simulator.
53 host_tools="texinfo byacc flex bison binutils ld gas gcc sim gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu ash bash bzip2 m4 autoconf automake libtool ispell grep diff rcs cvssrc fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils snavigator libtool gettext zip"
56 # these libraries are built for the target environment, and are built after
57 # the host libraries and the host tools (which may be a cross compiler)
59 target_libs="target-libiberty \
60 target-libgloss \
61 target-newlib \
62 target-libio \
63 target-librx \
64 target-libstdc++ \
65 target-libg++ \
66 target-libf2c \
67 target-libchill \
68 target-libjava \
69 target-zlib \
70 target-boehm-gc \
71 target-qthreads \
72 target-libobjc"
74 # these tools are built using the target libs, and are intended to run only
75 # in the target environment
77 # note: any program that *uses* libraries that are in the "target_libs"
78 # list belongs in this list. those programs are also very likely
79 # candidates for the "native_only" list which follows
81 target_tools="target-examples target-groff target-gperf"
83 ################################################################################
85 ## These two lists are of directories that are to be removed from the
86 ## ${configdirs} list for either cross-compilations or for native-
87 ## compilations. For example, it doesn't make that much sense to
88 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
89 ## a native environment.
91 # directories to be built in the native environment only
93 # This must be a single line because of the way it is searched by grep in
94 # the code below.
95 native_only="autoconf automake libtool cvssrc emacs emacs19 fileutils find gawk gettext grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time ash bash bzip2 prms snavigator gnuserv target-gperf"
97 # directories to be built in a cross environment only
99 cross_only="target-libgloss target-newlib target-cygmon target-opcodes target-libstub"
101 ## All tools belong in one of the four categories, and are assigned above
102 ## We assign ${configdirs} this way to remove all embedded newlines. This
103 ## is important because configure will choke if they ever get through.
104 ## ${configdirs} is directories we build using the host tools.
105 ## ${target_configdirs} is directories we build using the target tools.
107 configdirs=`echo ${host_libs} ${host_tools}`
108 target_configdirs=`echo ${target_libs} ${target_tools}`
110 ################################################################################
112 srctrigger=move-if-change
113 srcname="gnu development package"
115 # This gets set non-empty for some net releases of packages.
116 appdirs=""
118 # per-host:
120 # Work in distributions that contain no compiler tools, like Autoconf.
121 if [ -d ${srcdir}/config ]; then
122 case "${host}" in
123 m68k-hp-hpux*)
124 host_makefile_frag="${host_makefile_frag} config/mh-hp300"
126 m68k-apollo-sysv*)
127 host_makefile_frag="${host_makefile_frag} config/mh-apollo68"
129 m68k-apollo-bsd*)
130 host_makefile_frag="${host_makefile_frag} config/mh-a68bsd"
132 m88k-dg-dgux*)
133 host_makefile_frag="${host_makefile_frag} config/mh-dgux"
135 m88k-harris-cxux*)
136 host_makefile_frag="${host_makefile_frag} config/mh-cxux"
138 m88k-motorola-sysv*)
139 host_makefile_frag="${host_makefile_frag} config/mh-delta88"
141 mips*-dec-ultrix*)
142 host_makefile_frag="${host_makefile_frag} config/mh-decstation"
144 mips*-nec-sysv4*)
145 host_makefile_frag="${host_makefile_frag} config/mh-necv4"
147 mips*-sgi-irix6*)
148 host_makefile_frag="${host_makefile_frag} config/mh-irix6"
150 mips*-sgi-irix5*)
151 host_makefile_frag="${host_makefile_frag} config/mh-irix5"
153 mips*-sgi-irix4*)
154 host_makefile_frag="${host_makefile_frag} config/mh-irix4"
156 mips*-sgi-irix3*)
157 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
159 mips*-*-sysv4*)
160 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
162 mips*-*-sysv*)
163 host_makefile_frag="${host_makefile_frag} config/mh-riscos"
165 i[3456]86-*-sysv5*)
166 host_makefile_frag="${host_makefile_frag} config/mh-sysv5"
168 i[3456]86-*-dgux*)
169 host_makefile_frag="${host_makefile_frag} config/mh-dgux386"
171 i[3456]86-ncr-sysv4.3*)
172 host_makefile_frag="${host_makefile_frag} config/mh-ncrsvr43"
174 i[3456]86-ncr-sysv4*)
175 host_makefile_frag="${host_makefile_frag} config/mh-ncr3000"
177 i[3456]86-*-sco3.2v5*)
178 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
180 i[3456]86-*-sco*)
181 host_makefile_frag="${host_makefile_frag} config/mh-sco"
183 i[3456]86-*-udk*)
184 host_makefile_frag="${host_makefile_frag} config/mh-sysv5"
186 i[3456]86-*-isc*)
187 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
189 i[3456]86-*-solaris2*)
190 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
192 i[3456]86-*-aix*)
193 host_makefile_frag="${host_makefile_frag} config/mh-aix386"
195 i[3456]86-*-msdosdjgpp*)
196 host_makefile_frag="${host_makefile_frag} config/mh-djgpp"
198 *-cygwin32*)
199 host_makefile_frag="${host_makefile_frag} config/mh-cygwin"
201 *-mingw32*)
202 host_makefile_frag="${host_makefile_frag} config/mh-mingw32"
204 *-interix*)
205 host_makefile_frag="${host_makefile_frag} config/mh-interix"
207 *-windows*)
208 host_makefile_frag="${host_makefile_frag} config/mh-windows"
210 vax-*-ultrix2*)
211 host_makefile_frag="${host_makefile_frag} config/mh-vaxult2"
213 *-*-solaris2*)
214 host_makefile_frag="${host_makefile_frag} config/mh-solaris"
216 m68k-sun-sunos*)
217 host_makefile_frag="${host_makefile_frag} config/mh-sun3"
219 *-hp-hpux[78]*)
220 host_makefile_frag="${host_makefile_frag} config/mh-hpux8"
222 *-hp-hpux*)
223 host_makefile_frag="${host_makefile_frag} config/mh-hpux"
225 *-*-hiux*)
226 host_makefile_frag="${host_makefile_frag} config/mh-hpux"
228 rs6000-*-lynxos*)
229 host_makefile_frag="${host_makefile_frag} config/mh-lynxrs6k"
231 *-*-lynxos*)
232 host_makefile_frag="${host_makefile_frag} config/mh-lynxos"
234 *-*-aix4.[3456789]* | *-*-aix[56789].*)
235 host_makefile_frag="${host_makefile_frag} config/mh-aix43"
237 *-*-sysv4*)
238 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
240 *-*-sysv*)
241 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
243 esac
246 # If we aren't going to be using gcc, see if we can extract a definition
247 # of CC from the fragment.
248 if [ -z "${CC}" ] && [ "${build}" = "${host}" ]; then
249 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
250 found=
251 for dir in $PATH; do
252 test -z "$dir" && dir=.
253 if test -f $dir/gcc; then
254 found=yes
255 break
257 done
258 IFS="$save_ifs"
259 if [ -z "${found}" ] && [ -n "${host_makefile_frag}" ] && [ -f "${srcdir}/${host_makefile_frag}" ]; then
260 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
261 if [ -n "${xx}" ] ; then
262 CC=$xx
267 # We default to --with-shared on platforms where -fpic is meaningless.
268 # Well, we don't yet, but we will.
269 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
270 case "${target}" in
271 alpha*-dec-osf*) enable_shared=yes ;;
272 alpha*-*-linux*) enable_shared=yes ;;
273 mips-sgi-irix5*) enable_shared=yes ;;
274 *) enable_shared=no ;;
275 esac
278 case "${enable_shared}" in
279 yes) shared=yes ;;
280 no) shared=no ;;
281 "") shared=no ;;
282 *) shared=yes ;;
283 esac
285 if [ x${shared} = xyes ]; then
286 case "${host}" in
287 alpha*-*-linux*)
288 host_makefile_frag="${host_makefile_frag} config/mh-elfalphapic"
290 arm*-*-*)
291 host_makefile_frag="${host_makefile_frag} config/mh-armpic"
293 hppa*-*-*)
294 host_makefile_frag="${host_makefile_frag} config/mh-papic"
296 i[3456]86-*-cygwin32*)
297 # We don't want -fPIC on cygwin32.
299 i[3456]86-*-*)
300 host_makefile_frag="${host_makefile_frag} config/mh-x86pic"
302 sparc64-*-*)
303 host_makefile_frag="${host_makefile_frag} config/mh-sparcpic"
305 powerpc*-*-aix*)
306 # We don't want -fPIC on AIX.
308 powerpc*-*-*)
309 host_makefile_frag="${host_makefile_frag} config/mh-ppcpic"
311 *-*-*)
312 if test -f ${srcdir}/config/mh-${host_cpu}pic; then
313 host_makefile_frag="${host_makefile_frag} config/mh-${host_cpu}pic"
316 esac
319 rm -f mh-frag
320 if [ -n "${host_makefile_frag}" ] ; then
321 for f in ${host_makefile_frag}
323 cat ${srcdir}/$f >> mh-frag
324 done
325 host_makefile_frag=mh-frag
328 # per-target:
330 case "${target}" in
331 v810*)
332 target_makefile_frag="${target_makefile_frag} config/mt-v810"
334 i[3456]86-*-netware*)
335 target_makefile_frag="${target_makefile_frag} config/mt-netware"
337 powerpc-*-netware*)
338 target_makefile_frag="${target_makefile_frag} config/mt-netware"
340 *-*-linux-gnu)
341 target_makefile_frag="${target_makefile_frag} config/mt-linux"
343 esac
345 # If --enable-target-optspace always use -Os instead of -O2 to build
346 # the target libraries, similarly if it is not specified, use -Os
347 # on selected platforms.
348 case "${enable_target_optspace}:${target}" in
349 yes:*)
350 target_makefile_frag="${target_makefile_frag} config/mt-ospace"
352 :m32r-*)
353 target_makefile_frag="${target_makefile_frag} config/mt-ospace"
355 no:* | :*)
358 echo "*** bad value \"${enable_target_optspace}\" for --enable-target-optspace flag; ignored" 1>&2
360 esac
362 skipdirs=
363 gasdir=gas
364 use_gnu_ld=
365 use_gnu_as=
367 # some tools are so dependent upon X11 that if we're not building with X,
368 # it's not even worth trying to configure, much less build, that tool.
370 case ${with_x} in
371 yes | "") # the default value for this tree is that X11 is available
374 skipdirs="${skipdirs} tk libgui gash"
377 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
379 esac
381 # Some tools are only suitable for building in a "native" situation.
382 # Those are added when we have a host==target configuration. For cross
383 # toolchains, we add some directories that should only be useful in a
384 # cross-compiler.
386 is_cross_compiler=
388 if [ x"${host}" = x"${target}" ] ; then
389 # when doing a native toolchain, don't build the targets
390 # that are in the 'cross only' list
391 skipdirs="${skipdirs} ${cross_only}"
392 is_cross_compiler=no
393 else
394 # similarly, don't build the targets in the 'native only'
395 # list when building a cross compiler
396 skipdirs="${skipdirs} ${native_only}"
397 is_cross_compiler=yes
400 # We always want to use the same name for this directory, so that dejagnu
401 # can reliably find it.
402 target_subdir=${target_alias}
404 if [ ! -d ${target_subdir} ] ; then
405 if mkdir ${target_subdir} ; then true
406 else
407 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
408 exit 1
412 copy_dirs=
414 # Handle --with-headers=XXX. The contents of the named directory are
415 # copied to $(tooldir)/sys-include.
416 if [ x"${with_headers}" != x ]; then
417 if [ x${is_cross_compiler} = xno ]; then
418 echo 1>&2 '***' --with-headers is only supported when cross compiling
419 exit 1
421 case "${exec_prefixoption}" in
422 "") x=${prefix} ;;
423 *) x=${exec_prefix} ;;
424 esac
425 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
428 # Handle --with-libs=XXX. Multiple directories are permitted. The
429 # contents are copied to $(tooldir)/lib.
430 if [ x"${with_libs}" != x ]; then
431 if [ x${is_cross_compiler} = xno ]; then
432 echo 1>&2 '***' --with-libs is only supported when cross compiling
433 exit 1
435 # Copy the libraries in reverse order, so that files in the first named
436 # library override files in subsequent libraries.
437 case "${exec_prefixoption}" in
438 "") x=${prefix} ;;
439 *) x=${exec_prefix} ;;
440 esac
441 for l in ${with_libs}; do
442 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
443 done
446 # If both --with-headers and --with-libs are specified, default to
447 # --without-newlib.
448 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
449 if [ x"${with_newlib}" = x ]; then
450 with_newlib=no
454 # Recognize --with-newlib/--without-newlib.
455 if [ x${with_newlib} = xno ]; then
456 skipdirs="${skipdirs} target-newlib"
457 elif [ x${with_newlib} = xyes ]; then
458 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
461 # Default to using --with-stabs for certain targets.
462 if [ x${with_stabs} = x ]; then
463 case "${target}" in
464 mips*-*-irix6*)
466 mips*-*-* | alpha*-*-osf*)
467 with_stabs=yes;
468 withoptions="${withoptions} --with-stabs"
470 esac
473 # Handle ${copy_dirs}
474 set fnord ${copy_dirs}
475 shift
476 while [ $# != 0 ]; do
477 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
479 else
480 echo Copying $1 to $2
482 # Use the install script to create the directory and all required
483 # parent directories.
484 if [ -d $2 ]; then
486 else
487 echo >config.temp
488 ${srcdir}/install-sh -c -m 644 config.temp $2/COPIED
491 # Copy the directory, assuming we have tar.
492 # FIXME: Should we use B in the second tar? Not all systems support it.
493 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
495 # It is the responsibility of the user to correctly adjust all
496 # symlinks. If somebody can figure out how to handle them correctly
497 # here, feel free to add the code.
499 echo $1 > $2/COPIED
501 shift; shift
502 done
504 # Configure extra directories which are host specific
506 case "${host}" in
507 i[3456]86-*-go32*)
508 configdirs="$configdirs dosrel" ;;
509 i[3456]86-*-mingw32*)
510 configdirs="$configdirs dosrel" ;;
511 *-cygwin32*)
512 configdirs="$configdirs dosrel" ;;
513 esac
515 # Remove more programs from consideration, based on the host or
516 # target this usually means that a port of the program doesn't
517 # exist yet.
519 noconfigdirs=""
521 case "${host}" in
522 i[3456]86-*-vsta)
523 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv gettext"
525 i[3456]86-*-go32* | i[3456]86-*-msdosdjgpp*)
526 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv gettext"
528 i[3456]86-*-mingw32*)
529 # noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv"
530 noconfigdirs="expect dejagnu cvs autoconf automake send-pr gprof rcs guile perl texinfo apache inet libtool"
532 *-*-cygwin32)
533 noconfigdirs="autoconf automake send-pr gprof rcs guile perl apache inet"
535 *-*-windows*)
536 # This is only used to build WinGDB...
537 # note that powerpc-eabi depends on sim configured before gdb.
538 configdirs="bfd libiberty opcodes readline sim gdb"
539 target_configdirs=
541 *-*-netbsd*)
542 noconfigdirs="rcs"
544 ppc*-*-pe)
545 noconfigdirs="patch diff make tk tcl expect dejagnu cvssrc autoconf automake texinfo bison send-pr gprof rcs guile perl apache inet itcl tix db snavigator gnuserv"
547 esac
550 case "${target}" in
551 *-*-netware)
552 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
554 *-*-rtems*)
555 noconfigdirs="$noconfigdirs target-libgloss"
557 *-*-vxworks*)
558 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
560 alpha*-dec-osf*)
561 # ld works, but does not support shared libraries. emacs doesn't
562 # work. newlib is not 64 bit ready. I'm not sure about fileutils.
563 # gas doesn't generate exception information.
564 noconfigdirs="$noconfigdirs gas ld emacs fileutils target-newlib target-libgloss"
566 alpha*-*-*vms*)
567 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
569 alpha*-*-linux*)
570 # newlib is not 64 bit ready
571 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
572 # linux has rx in libc
573 skipdirs="$skipdirs target-librx"
575 alpha*-*-*)
576 # newlib is not 64 bit ready
577 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
579 arc-*-*)
580 noconfigdirs="$noconfigdirs target-libgloss"
582 arm-*-pe*)
583 noconfigdirs="$noconfigdirs target-libgloss"
585 arm-*-coff*)
586 noconfigdirs="$noconfigdirs target-libgloss"
588 arm-*-elf*)
589 noconfigdirs="$noconfigdirs target-libgloss"
590 if [ x${is_cross_compiler} != xno ] ; then
591 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
594 arm-*-oabi*)
595 noconfigdirs="$noconfigdirs target-libgloss"
596 if [ x${is_cross_compiler} != xno ] ; then
597 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
600 c4x-*-*)
601 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
603 thumb-*-coff)
604 noconfigdirs="$noconfigdirs target-libgloss"
606 arm-*-riscix*)
607 noconfigdirs="$noconfigdirs ld target-libgloss"
609 d10v-*-*)
610 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
612 h8300*-*-* | \
613 h8500-*-*)
614 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
616 hppa*-*-*elf* | \
617 hppa*-*-lites*)
618 # Do configure ld/binutils/gas for this case.
620 hppa*-*-*)
621 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
622 # cc is gcc, and on any system a user should be able to link cc to
623 # whatever they want. FIXME, emacs emacs19).
624 case "${CC}" in
625 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
626 *) ;;
627 esac
628 noconfigdirs="$noconfigdirs ld shellutils"
630 i[3456]86-*-go32* | i[3456]-*-msdosdjgpp*)
631 # but don't build gdb
632 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
634 *-*-linux*)
635 # linux has rx in libc
636 skipdirs="$skipdirs target-librx"
638 i[3456]86-*-mingw32*)
639 target_configdirs="$target_configdirs target-mingw"
640 noconfigdirs="$noconfigdirs expect target-libgloss"
642 # Can't build gdb for mingw32 if not native.
643 case "${host}" in
644 i[3456]86-*-mingw32) ;; # keep gdb tcl tk expect etc.
645 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix db snavigator gnuserv"
647 esac
649 *-*-cygwin32*)
650 target_configdirs="$target_configdirs target-winsup"
651 noconfigdirs="$noconfigdirs target-gperf target-libgloss"
652 # always build newlib.
653 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
655 # Can't build gdb for cygwin32 if not native.
656 case "${host}" in
657 *-*-cygwin32*) ;; # keep gdb tcl tk expect etc.
658 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix libgui db snavigator gnuserv"
660 esac
662 i[3456]86-*-pe)
663 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
665 i[3456]86-*-sco3.2v5*)
666 # The linker does not yet know about weak symbols in COFF,
667 # and is not configured to handle mixed ELF and COFF.
668 noconfigdirs="$noconfigdirs ld target-libgloss"
670 i[3456]86-*-sco*)
671 noconfigdirs="$noconfigdirs gprof target-libgloss"
673 i[3456]86-*-solaris2*)
674 # The linker does static linking correctly, but the Solaris C library
675 # has bugs such that some important functions won't work when statically
676 # linked. (See man pages for getpwuid, for example.)
677 noconfigdirs="$noconfigdirs ld target-libgloss"
679 i[3456]86-*-sysv4*)
680 # The SYSV4 C compiler doesn't handle Emacs correctly
681 case "${CC}" in
682 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
683 *) ;;
684 esac
685 # but that's okay since emacs doesn't work anyway
686 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
688 mn10200-*-*)
689 noconfigdirs="$noconfigdirs"
690 if [ x${is_cross_compiler} != xno ] ; then
691 target_configdirs="${target_configdirs} target-libstub target-cygmon"
694 mn10300-*-*)
695 noconfigdirs="$noconfigdirs"
696 if [ x${is_cross_compiler} != xno ] ; then
697 target_configdirs="${target_configdirs} target-libstub target-cygmon"
700 powerpc-*-aix*)
701 # copied from rs6000-*-* entry
702 noconfigdirs="$noconfigdirs gprof cvssrc target-libgloss"
703 # This is needed until gcc and ld are fixed to work together.
704 use_gnu_ld=no
706 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
707 target_configdirs="$target_configdirs target-winsup"
708 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss itcl tix db snavigator gnuserv"
709 # always build newlib.
710 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
712 # This is temporary until we can link against shared libraries
713 powerpcle-*-solaris*)
714 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect itcl tix db snavigator gnuserv"
716 rs6000-*-lynxos*)
717 # The CVS server code doesn't work on the RS/6000
718 # Newlib makes problems for libg++ in crosses.
719 noconfigdirs="$noconfigdirs target-newlib gprof cvssrc"
721 rs6000-*-aix*)
722 noconfigdirs="$noconfigdirs gprof"
723 # This is needed until gcc and ld are fixed to work together.
724 use_gnu_ld=no
726 rs6000-*-*)
727 noconfigdirs="$noconfigdirs gprof"
729 m68k-apollo-*)
730 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
732 mips*-*-irix5*)
733 # The GNU linker does not support shared libraries.
734 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
735 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
737 mips*-*-irix6*)
738 # The GNU assembler and linker do not support IRIX 6.
739 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
740 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
742 mips*-dec-bsd*)
743 noconfigdirs="$noconfigdirs gprof target-libgloss"
745 mips*-*-bsd*)
746 noconfigdirs="$noconfigdirs gprof target-libgloss"
748 mipstx39-*-*)
749 noconfigdirs="$noconfigdirs gprof" # same as generic mips
750 target_configdirs="${target_configdirs} target-libstub target-cygmon"
752 mips*-*-*)
753 noconfigdirs="$noconfigdirs gprof"
755 romp-*-*)
756 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
758 sh-*-*)
759 case "${host}" in
760 i[3456]86-*-vsta) ;; # don't add gprof back in
761 i[3456]86-*-go32*) ;; # don't add gprof back in
762 i[3456]86-*-msdosdjgpp*) ;; # don't add gprof back in
763 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
764 esac
765 noconfigdirs="$noconfigdirs target-libgloss"
767 sparc-*-elf*)
768 if [ x${is_cross_compiler} != xno ] ; then
769 target_configdirs="${target_configdirs} target-libstub target-cygmon"
772 sparc64-*-elf*)
773 if [ x${is_cross_compiler} != xno ] ; then
774 target_configdirs="${target_configdirs} target-libstub target-cygmon"
777 sparclite-*-aout*)
778 if [ x${is_cross_compiler} != xno ] ; then
779 target_configdirs="${target_configdirs} target-libstub target-cygmon"
782 sparc-*-sunos4*)
783 if [ x${is_cross_compiler} != xno ] ; then
784 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
785 else
786 use_gnu_ld=no
789 v810-*-*)
790 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
792 v850-*-*)
793 noconfigdirs="$noconfigdirs target-libgloss"
795 vax-*-vms)
796 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
798 vax-*-*)
799 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
801 *-*-lynxos*)
802 # Newlib makes problems for libg++ in crosses.
803 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
805 *-*-macos* | \
806 *-*-mpw*)
807 # Macs want a resource compiler.
808 configdirs="$configdirs grez"
810 esac
812 # If we aren't building newlib, then don't build libgloss, since libgloss
813 # depends upon some newlib header files.
814 case "${noconfigdirs}" in
815 *target-libgloss*) ;;
816 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
817 esac
819 # Make sure we don't let GNU ld be added if we didn't want it.
820 if [ x$with_gnu_ld = xno ]; then
821 use_gnu_ld=no
822 noconfigdirs="$noconfigdirs ld"
825 # Make sure we don't let GNU as be added if we didn't want it.
826 if [ x$with_gnu_as = xno ]; then
827 use_gnu_as=no
828 noconfigdirs="$noconfigdirs gas"
831 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
832 # $target_configdirs.
833 # If we have the source for $noconfigdirs entries, add them to $notsupp.
835 notsupp=""
836 for dir in . $skipdirs $noconfigdirs ; do
837 dirname=`echo $dir | sed -e s/target-//g`
838 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
839 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
840 if [ -r $srcdir/$dirname/configure ] \
841 || [ -r $srcdir/$dirname/configure.in ]; then
842 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
843 true
844 else
845 notsupp="$notsupp $dir"
849 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
850 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
851 if [ -r $srcdir/$dirname/configure ] \
852 || [ -r $srcdir/$dirname/configure.in ]; then
853 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
854 true
855 else
856 notsupp="$notsupp $dir"
860 done
862 # Sometimes the tools are distributed with libiberty but with no other
863 # libraries. In that case, we don't want to build target-libiberty.
864 if [ -n "${target_configdirs}" ]; then
865 others=
866 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
867 if [ "$i" != "libiberty" ]; then
868 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
869 others=yes;
870 break;
873 done
874 if [ -z "${others}" ]; then
875 target_configdirs=
879 # Deconfigure all subdirectories, in case we are changing the
880 # configuration from one where a subdirectory is supported to one where it
881 # is not.
882 if [ -z "${norecursion}" ] && [ -n "${configdirs}" ]; then
883 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
884 rm -f $i/Makefile
885 done
887 if [ -z "${norecursion}" ] && [ -n "${target_configdirs}" ]; then
888 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
889 rm -f ${target_subdir}/$i/Makefile
890 done
893 # Produce a warning message for the subdirs we can't configure.
894 # This isn't especially interesting in the Cygnus tree, but in the individual
895 # FSF releases, it's important to let people know when their machine isn't
896 # supported by the one or two programs in a package.
898 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
899 # If $appdirs is non-empty, at least one of those directories must still
900 # be configured, or we error out. (E.g., if the gas release supports a
901 # specified target in some subdirs but not the gas subdir, we shouldn't
902 # pretend that all is well.)
903 if [ -n "$appdirs" ]; then
904 for dir in $appdirs ; do
905 if [ -r $dir/Makefile.in ]; then
906 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
907 appdirs=""
908 break
910 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
911 appdirs=""
912 break
915 done
916 if [ -n "$appdirs" ]; then
917 echo "*** This configuration is not supported by this package." 1>&2
918 exit 1
921 # Okay, some application will build, or we don't care to check. Still
922 # notify of subdirs not getting built.
923 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
924 echo " ${notsupp}" 1>&2
925 echo " (Any other directories should still work fine.)" 1>&2
928 # Set with_gnu_as and with_gnu_ld as appropriate.
930 # This is done by determining whether or not the appropriate directory
931 # is available, and by checking whether or not specific configurations
932 # have requested that this magic not happen.
934 # The command line options always override the explicit settings in
935 # configure.in, and the settings in configure.in override this magic.
937 # If the default for a toolchain is to use GNU as and ld, and you don't
938 # want to do that, then you should use the --without-gnu-as and
939 # --without-gnu-ld options for the configure script.
941 if [ x${use_gnu_as} = x ] ; then
942 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
943 with_gnu_as=yes
944 withoptions="$withoptions --with-gnu-as"
948 if [ x${use_gnu_ld} = x ] ; then
949 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
950 with_gnu_ld=yes
951 withoptions="$withoptions --with-gnu-ld"
955 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
956 # can detect this case.
958 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
959 with_newlib=yes
960 withoptions="$withoptions --with-newlib"
963 if [ x${shared} = xyes ]; then
964 case "${target}" in
965 hppa*)
966 target_makefile_frag="${target_makefile_frag} config/mt-papic"
968 i[3456]86-*)
969 target_makefile_frag="${target_makefile_frag} config/mt-x86pic"
971 powerpc*-*)
972 target_makefile_frag="${target_makefile_frag} config/mt-ppcpic"
974 alpha*-*-linux*)
975 target_makefile_frag="${target_makefile_frag} config/mt-elfalphapic"
978 if test -f ${srcdir}/config/mt-${target_cpu}pic; then
979 target_makefile_frag="${target_makefile_frag} config/mt-${target_cpu}pic"
982 esac
985 rm -f mt-frag
986 if [ -n "${target_makefile_frag}" ] ; then
987 for f in ${target_makefile_frag}
989 cat ${srcdir}/$f >> mt-frag
990 done
991 target_makefile_frag=mt-frag
994 # post-target:
996 # Make sure that the compiler is able to generate an executable. If it
997 # can't, we are probably in trouble. We don't care whether we can run the
998 # executable--we might be using a cross compiler--we only care whether it
999 # can be created. At this point the main configure script has set CC.
1000 echo "int main () { return 0; }" > conftest.c
1001 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
1002 if [ $? = 0 ] && [ -s conftest -o -s conftest.exe ]; then
1004 else
1005 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
1006 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
1007 rm -f conftest*
1008 exit 1
1010 rm -f conftest*
1012 # The Solaris /usr/ucb/cc compiler does not appear to work.
1013 case "${host}" in
1014 sparc-sun-solaris2*)
1015 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
1016 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
1017 could_use=
1018 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
1019 if [ -d /opt/cygnus/bin ] ; then
1020 if [ "$could_use" = "" ] ; then
1021 could_use="/opt/cygnus/bin"
1022 else
1023 could_use="$could_use or /opt/cygnus/bin"
1026 if [ "$could_use" = "" ] ; then
1027 echo "Warning: compilation may fail because you're using"
1028 echo "/usr/ucb/cc. You should change your PATH or CC "
1029 echo "variable and rerun configure."
1030 else
1031 echo "Warning: compilation may fail because you're using"
1032 echo "/usr/ucb/cc, when you should use the C compiler from"
1033 echo "$could_use. You should change your"
1034 echo "PATH or CC variable and rerun configure."
1038 esac
1040 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
1041 # binutils tools will find libbfd.so.
1042 if [ "${shared}" = "yes" ]; then
1043 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
1044 Makefile > Makefile.tem
1045 rm -f Makefile
1046 mv -f Makefile.tem Makefile
1048 case "${host}" in
1049 *-*-hpux*)
1050 sed -e 's/^RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
1051 Makefile > Makefile.tem
1052 rm -f Makefile
1053 mv -f Makefile.tem Makefile
1055 esac
1058 # Record target_configdirs and the configure arguments in Makefile.
1059 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
1060 targargs=`echo "${arguments}" | \
1061 sed -e 's/--no[^ ]*//' \
1062 -e 's/--cache[a-z-]*=[^ ]*//' \
1063 -e 's/--ho[a-z-]*=[^ ]*//' \
1064 -e 's/--bu[a-z-]*=[^ ]*//' \
1065 -e 's/--ta[a-z-]*=[^ ]*//'`
1067 # Passing a --with-cross-host argument lets the target libraries know
1068 # whether they are being built with a cross-compiler or being built
1069 # native. However, it would be better to use other mechanisms to make the
1070 # sorts of decisions they want to make on this basis. Please consider
1071 # this option to be deprecated. FIXME.
1072 if [ x${is_cross_compiler} = xyes ]; then
1073 targargs="--with-cross-host=${host_alias} ${targargs}"
1076 # Default to --enable-multilib.
1077 if [ x${enable_multilib} = x ]; then
1078 targargs="--enable-multilib ${targargs}"
1081 # Pass --with-newlib if appropriate. Note that target_configdirs has
1082 # changed from the earlier setting of with_newlib.
1083 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
1084 targargs="--with-newlib ${targargs}"
1087 # provide a proper gxx_include_dir.
1088 # Note, if you change the default, make sure to fix both here and in
1089 # the gcc, libio, libstdc++ and libg++ subdirectories.
1090 # Check whether --with-gxx-include-dir or --without-gxx-include-dir was given.
1091 gxx_include_dir=
1092 if test -n "${with_gxx_include_dir}"; then
1093 case "${with_gxx_include_dir}" in
1094 yes )
1095 echo "configure.in: error: bad value ${withval} given for g++ include directory" 1>&2
1096 exit 1
1098 no )
1101 gxx_include_dir=${with_gxx_include_dir}
1103 esac
1105 if test x${gxx_include_dir} = x; then
1106 if test x${enable_version_specific_runtime_libs} = xyes; then
1107 gxx_include_dir='${libsubdir}/include/g++'
1108 else
1109 . ${topsrcdir}/config.if
1110 gxx_include_dir='${prefix}/include/g++'-${libstdcxx_interface}
1112 else
1113 gxx_include_dir=${gxx_include_dir}
1116 targargs="--host=${target_alias} --build=${build_alias} ${targargs}"
1117 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
1118 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
1119 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
1120 -e "s%^gxx_include_dir[ ]*=.*$%gxx_include_dir=${gxx_include_dir}%" \
1121 Makefile > Makefile.tem
1122 rm -f Makefile
1123 mv -f Makefile.tem Makefile
1126 # Local Variables:
1127 # fill-column: 131
1128 # End: